//TabStopVerteiler_D_501d.js
// 29.04.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Tabstops ausrichten

/*
Credits: Eine Erweiterung des Scripts "spaltenbreite_nach_lngster_spalte.jsx" 
von Gerald Singelmann (-> http://www.cuppascript.com 	)
*/

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// zwei Flags, damit die beiden Dialoge nur je einmal gezeigt werden
dlog_N_shown = false;
dlog_Y_shown = false;

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs_N = getPrefs_N(); // fr Abstze ohne Tabstop-Definitionen
if (allPrefs_N != "") {
	var prefVal_N = allPrefs_N.split("\n");
	// Option 1: den Dialog zeigen (= 1) oder nicht (= 0)
	showDlog_N = prefVal_N[0];
	if (showDlog_N == "0") {
		ck00 = 1;
		ck01 = 0;
	}
	else {
		ck00 = 0;
		ck01 = 1;
	}
	// Option 2: der Abstand zwischen den Spalten (wenn keine Tabstops definiert sind)
	horGap = prefVal_N[1]*1;
	// Option 4: die Rundungs-"Feinheit" der neuen Positionswerte
	// 0 = nicht runden;  0.1 = Zehntelsmillimeter;  0.5 = halbe Millimeter;  1 = ganze Millimeter
	// Als Dezimaltrennzeichen nicht ein Komma, sondern einen Punkt tippen
	rndFact_N = prefVal_N[2]*1;
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	showDlog_N = "1";
	ck00       = 0;
	ck01       = 1;
	horGap     = 4;
	rndFact_N  = 0.1;
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs_Y = getPrefs_Y(); // fr Abstze mit Tabstop-Definitionen
if (allPrefs_Y != "") {
	var prefVal_Y = allPrefs_Y.split("\n");
	// Option 1: den Dialog zeigen (= 1) oder nicht (= 0)
	showDlog_Y = prefVal_Y[0];
	if (showDlog_Y == "0") {
		ck02 = 1;
		ck03 = 0;
	}
	else {
		ck02 = 0;
		ck03 = 1;
	}
	// Option 3: der erste zu verndernde Tabstop
	firstStop = prefVal_Y[1]*1;
	// Option 4: die Rundungs-"Feinheit" der neuen Positionswerte
	// 0 = nicht runden;  0.1 = Zehntelsmillimeter;  0.5 = halbe Millimeter;  1 = ganze Millimeter
	// Als Dezimaltrennzeichen nicht ein Komma, sondern einen Punkt tippen
	rndFact_Y = prefVal_Y[2]*1;
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	showDlog_Y = "1";
	ck02       = 0;
	ck03       = 1;
	firstStop  = 1;
	rndFact_Y  = 0.1;
}

// drei weitere Funktionen aufrufen
firstChecks();
reStore();
infUser();


///////////////////// die Funktionen  ////////////////////////////////////////////

// die Funktionen, welche die Informationen vorbereiten //////////////////////////
function getPrefs_N() {
	var allPrefs_N = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/TabStops_No_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/TabStops_No_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs_N = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs_N;
}

function getPrefs_Y() {
	var allPrefs_Y = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/TabStops_Yes_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/TabStops_Yes_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs_Y = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs_Y;
}

// erste Prfungen ///////////////////////////////////////////////////////////////
function firstChecks() {
	// testen, ob ein Dokument geffnet ist
	if (app.documents.length == 0) {
		alert ("Es ist kein Dokument offen.", "Achtung");
		exit();
	}
	
	// das aktuelle Dokument
	curDoc = app.documents[0];
	
	// die Vorgabenwerte prfen
	try {
		if (isNaN(horGap)) {
			horGap = 4;
		}
	}
	catch (e) {
		horGap = 4;
	}
	if (horGap < 1) {
		horGap = 1;
	}
	try {
		if (isNaN(firstStop)) {
			firstStop = 1;
		}
	}
	catch (e) {
		firstStop = 1;
	}
	if (firstStop < 0) {
		firstStop = 1;
	}
	firstStop = Math.floor(firstStop);
	if (firstStop == 0) {
		firstStop = 1;
	}
	try {
		if (isNaN(rndFact_N)) {
			rndFact_N = 0.1;
		}
	}
	catch (e) {
		rndFact_N = 0.1;
	}
	if (rndFact_N != 0 && rndFact_N != 0.1 && rndFact_N != 0.5 && rndFact_N != 1) {
		rndFact_N = 0.1;
	}
	try {
		if (isNaN(rndFact_Y)) {
			rndFact_Y = 0.1;
		}
	}
	catch (e) {
		rndFact_Y = 0.1;
	}
	if (rndFact_Y != 0 && rndFact_Y != 0.1 && rndFact_Y != 0.5 && rndFact_Y != 1) {
		rndFact_Y = 0.1;
	}

	// die Auswahl speichern und prfen
	curSel = app.selection;
	if (curSel.length == 0) {
		alert ("Es ist nichts ausgewhlt.", "Achtung");
		exit();
	}
	if (curSel[0].hasOwnProperty("baseline") == true) {
		if (curSel[0].contents.indexOf("\t") == -1) {
			alert ("Kein tabellarischer Text ausgewhlt.", "Stop");
			exit();
		}
		changeUnits();
		var isLocked = false;
		if (curSel[0].parent.textContainers[0].locked == true) {
			curSel[0].parent.textContainers[0].locked = false;
			isLocked = true;
		}
		checkParas(curSel[0]);
		if (isLocked) {
			curSel[0].parent.textContainers[0].locked = true;
		}
	}
	else {
		changeUnits();
		for (var s=0; s<curSel.length; s++) {
			var curType = curSel[s].constructor.name;
			var isLocked = false;
			if (curType == "TextFrame") {
				if (curSel[s].locked == true) {
					curSel[s].locked = false;
					isLocked = true;
				}
				checkParas(curSel[s]);
				if (isLocked) {
					curSel[s].locked = true;
				}
			}
			else if (curType == "Group") {
				if (curSel[s].locked == true) {
					curSel[s].locked = false;
					isLocked = true;
				}
				var allItems = curSel[s].allPageItems;
				for (var n=0; n<allItems.length; n++) {
					var curType = allItems[n].constructor.name;
					if (curType == "TextFrame") {
						checkParas(allItems[n]);
					}
				}
				if (isLocked) {
					curSel[s].locked = true;
				}
			}
		}
	}
}

// Masseinheiten und Nullpunkt prfen und ndern /////////////////////////////////
function changeUnits() {
	// die Masseinheiten speichern
	// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
	hM = curDoc.viewPreferences.horizontalMeasurementUnits;
	vM = curDoc.viewPreferences.verticalMeasurementUnits;
	
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// den Nullpunkt auf Null/Null setzen
	zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
}

// die Abstze prfen ////////////////////////////////////////////////////////////
function checkParas(sel) {
	// die Abstze der Auswahl und deren Anzahl
	allParas = sel.paragraphs;
	nParas = allParas.length;
	
	// eine Schleife durch die Abstze
	startPara = -1;
	for (var p=0; p<nParas; p++) {
		if (allParas[p].contents.indexOf("\t") != -1) {
			startPara = p;
			break;
		}
	}
	if (startPara == -1) {
		return;
	}
	
	// feststellen, ob Tabstops definiert sind
	if (allParas[startPara].tabStops.length != 0) {
		noStops = false;
	}
	else {
		noStops = true;
	}
	
	// prfen, ob ein Einzug definiert ist
	if (noStops == false) {
		leftInd  = allParas[startPara].leftIndent;
		firstInd = allParas[startPara].firstLineIndent;
	}

	// die Suchen/Ersetzen-Vorgaben zurcksetzen
	app.findGrepPreferences = app.changeGrepPreferences = null;
	
	// die Suchen-Vorgabe
	app.findGrepPreferences.findWhat = "\t|~y";
	
	allTabs = new Array();
	allLines = sel.lines;
	nLines   = allLines.length;
	// eine Schleife durch die Zeilen
	for (var n=0; n<nLines; n++) {
		var curRes = allLines[n].findGrep();
		if (curRes.length != 0) {
			allTabs.push(curRes);
		}
	}
	
	// die Suchen/Ersetzen-Vorgaben zurcksetzen
	app.findGrepPreferences = app.changeGrepPreferences = null;
	
	// die Funktion zum Errechnen und ndern der Positionen aufrufen
	changeTabPos();
}

// die Tabstop-Positionen ndern (oder definieren) ///////////////////////////////
function changeTabPos() {
	// wenn keine Tabstops definiert sind
	if (noStops) {
		// den Dialog zeigen (wenn der Wert von 'showDlog_N' "1" ist)
		if (showDlog_N == "1") {
			// aber nur beim ersten Mal der aktuellen Sitzung
			if (dlog_N_shown == false) {
				var anArray  = askUser_No();
				horGap       = anArray[0];
				rndFact_N    = anArray[1];
				dlog_N_shown = true;
			}
		}
		// die horizontale Position des ersten Absatzes
		var startVal = allParas[startPara].insertionPoints[0].horizontalOffset;
		// runden der Vorgabe entsprechend, damit die Position des Textrahmens 
		// nicht das Ergebnis verflscht
		if (rndFact_N != 0) {
			startVal = Math.round(startVal/rndFact_N)*rndFact_N;
		}
		var nTabs = allTabs[0].length;
		var nPara = allParas.length;
		// den Stopwert-Modifizierwert definieren
		var stopMod = 0;
		// feststellen, ob ein Zeilenspalter vorhanden ist
		if (allParas[startPara].contents.indexOf("\u0008") != -1) {
			// wenn ja, den Stopwert-Modifizierwert ndern
			stopMod = 1;
		}
		// die lngste Zeile jeder Spalte ermitteln
		for (var t=0; t<nTabs-stopMod; t++) {
			var x = -999;
			for (var n=0; n<nLines; n++) {
				var pTabs = allTabs[n];
				try {
					x = Math.max(x, pTabs[t].horizontalOffset);
				}
				catch (e) {
				}
			}
			// das Ergebnis runden
			if (rndFact_N != 0) {
				x = Math.round(x/rndFact_N)*rndFact_N;
			}
			// jedem Absatz einen neuen Tabstop zuweisen ...
			for (var p=0; p<nParas; p++) {
				// ... falls Tabulatoren enthalten sind
				if (allParas[p].contents.indexOf("\t") != -1) {
					allParas[p].tabStops.add({alignment:TabStopAlignment.LEFT_ALIGN, position:x-startVal+horGap});
				}
			}
		}
	}
	// wenn schon Tabstops vorhanden sind
	else {
		// den Dialog zeigen (wenn der Wert von 'showDlog_Y' 1 ist)
		if (showDlog_Y == "1") {
			// aber nur beim ersten Mal der aktuellen Sitzung
			if (dlog_Y_shown == false) {
				var anArray  = askUser_Yes();
				firstStop    = anArray[0];
				rndFact_Y    = anArray[1];
				dlog_Y_shown = true;
			}
		}
		startCol = firstStop-1;
		var horOffsets = new Array();
		var nTabs = allTabs[0].length;
		var nPara = allParas.length;
		// prfen, ob ein Einzug definiert ist
		var withIndent = false;
		var mv = 0;
		if (leftInd > 0) {
			var startVal = Math.round((allParas[startPara].insertionPoints[0].horizontalOffset)*1000)/1000;
			var firstEnd = Math.round((allTabs[0][0].insertionPoints[-1].horizontalOffset)*1000)/1000;
			if (firstEnd+firstInd == startVal) {
				withIndent = true;
				if (allParas[startPara].tabStops[0].position == leftInd) {
					mv = 1;
				}
			}
		}
		// die Positionen der Tabstops vereinheitlichen
		var allStops = allParas[startPara].tabList;
		for (var p=0; p<allParas.length; p++) {
			if (allParas[p].tabStops.length != 0) {
				try {
					allParas[p].tabList = allStops;
				}
				catch (e) {
				}
			}
		}
		
		// prfen, ob der erste Absatz mit einem Tab anfngt
		// wenn das zutrifft, den Wert fr die Startspalte auf 2 setzen (= Spalte 3)
		// falls nicht schon anders als Null definiert
		if (allParas[startPara].characters[0].contents == "\t") {
			if (startCol == 0) {
				startCol = 2;
			}
		}
		
		// die Max- und Min-Positionen der Abstnde zwischen den Spalten ermitteln ...
		if (withIndent == false) { // wenn kein Einzug definiert ist
			for (var t=startCol; t<nTabs; t++) {
				var x1 = -999;
				var x2 = 999;
				for (var n=0; n<allTabs.length; n++) {
					var pTabs = allTabs[n];
					try {
						x1 = Math.max(x1, pTabs[t].insertionPoints[0].horizontalOffset);
						x2 = Math.min(x2, pTabs[t].insertionPoints[-1].horizontalOffset);
					}
					catch (e) {
					}
				}
				// ... und an den Array hngen
				horOffsets.push([x1, x2]);
			}
		}
		else { // wenn ein Einzug definiert ist
			for (var t=startCol; t<nTabs; t++) {
				var x1 = -999;
				var x2 = 999;
				for (var n=0; n<allTabs.length; n++) {
					if (allLines[n].contents.indexOf("\t") != -1) {
						var pTabs = allTabs[n];
						if (pTabs.length == nTabs) {
							try {
								x1 = Math.max(x1, pTabs[t+1].insertionPoints[0].horizontalOffset);
								x2 = Math.min(x2, pTabs[t+1].insertionPoints[-1].horizontalOffset);
							}
							catch (e) {
							}
						}
						else {
							try {
								x1 = Math.max(x1, pTabs[t].insertionPoints[0].horizontalOffset);
								x2 = Math.min(x2, pTabs[t].insertionPoints[-1].horizontalOffset);
							}
							catch (e) {
							}
						}
					}
				}
				// ... und an den Array hngen
				if (x1 != -999) {
					horOffsets.push([x1, x2]);
				}
			}
		}
		// die Minimal-Abstnde errechnen und auflisten
		var oldSpaces = new Array();
		for (var n=0; n<horOffsets.length; n++) {
			oldSpaces.push(horOffsets[n][1]-horOffsets[n][0]);
		}
		// die Abstnde zusammenzhlen ...
		var allSpaces = 0;
		for (var n=0; n<oldSpaces.length; n++) {
			allSpaces += oldSpaces[n];
		}
		// wenn kein Einzug definiert ist
		if (withIndent == false) {
			// ... und den Durchschnitt ausrechnen
			var newSpace = allSpaces/(nTabs-startCol);
			// die Differenzen auflisten
			var dif = 0;
			var difPosArr = new Array();
			for (var n=0; n<(nTabs-1)-startCol; n++) {
				var curDif = (newSpace-oldSpaces[n]);
				difPosArr.push(curDif+dif);
				dif += curDif;
			}
			// die neuen Positionen errechnen
			var newPos = new Array();
			for (var t=0; t<difPosArr.length; t++) {
				try {
					x = (allParas[startPara].tabStops[t+startCol].position)+difPosArr[t];
					if (rndFact_Y != 0) {
						x = Math.round(x/rndFact_Y)*rndFact_Y;
					}
					newPos.push(x);
				}
				catch (e) {
					alert ("Klappt leider nicht.", "Sorry");
					reStore();
					exit();
				}
			}
			// die Tabliste speichern
			var allStops = allParas[startPara].tabList;
			// den Tabstops die neue Position zuweisen
			for (var t=0; t<newPos.length; t++) {
				allStops[t+startCol].position = newPos[t];
			}
			// den Abstzen die genderte Tabstop-Definition zuweisen
			for (var n=0; n<nPara; n++) {
				try {
					if (allParas[n].tabStops.length != 0) {
						allParas[n].tabList = allStops;
					}
				}
				catch (e) {
				}
			}
		}
		// den Einzug bercksichtigen
		else {
			// ... und den Durchschnitt ausrechnen
			var newSpace = allSpaces/(nTabs-startCol-1);
			// die Differenzen auflisten
			var dif = 0;
			var difPosArr = new Array();
			for (var n=0; n<(nTabs-1)-startCol; n++) {
				var curDif = (newSpace-oldSpaces[n]);
				difPosArr.push(curDif+dif);
				dif += curDif;
			}
			// die neuen Positionen errechnen
			var newPos = new Array();
			for (var t=0; t<difPosArr.length; t++) {
				try {
					x = (allParas[startPara].tabStops[t+startCol+mv].position)+difPosArr[t];
					if (rndFact_Y != 0) {
						x = Math.round(x/rndFact_Y)*rndFact_Y;
					}
					newPos.push(x);
				}
				catch (e) {
					alert ("Klappt leider nicht.", "Sorry");
					reStore();
					exit();
				}
			}
			// die Tabliste speichern
			var allStops = allParas[startPara].tabList;
			// den Tabstops die neue Position zuweisen
			for (var t=0; t<newPos.length; t++) {
				allStops[t+startCol].position = newPos[t];
			}
			// den Abstzen die genderte Tabstop-Definition zuweisen
			for (var n=0; n<nPara; n++) {
				try {
					if (allParas[n].tabStops.length != 0) {
						allParas[n].tabList = allStops;
					}
				}
				catch (e) {
				}
			}
		}
	}
}

// den Dialog vorbereiten und anzeigen ///////////////////////////////////////////
function askUser_No() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 184;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"Keine TabStops definiert"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Spaltenabstand:", minWidth:labelWidth});
						var gapField = realEditboxes.add({editValue:horGap, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Rundung der Positionen:", minWidth:labelWidth});
						var rndField = realEditboxes.add({editValue:rndFact_N, minWidth:fieldWidth});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:70});
				with(showButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"Dialog nicht mehr zeigen", checkedState:ck00});
					radiobuttonControls.add({staticLabel:"Dialog zeigen", checkedState:ck01});
				}
			}
		}
	}
	if (aDialog.show() == true) {
		// die Eingaben auswerten
		showDlog_N = showButtons.selectedButton;
		horGap     = gapField.editValue;
		rndFact_N  = rndField.editValue;
		// den Dialog entfernen
		aDialog.destroy();
		// die Eingabe testen
		if (rndFact_N != 0 && rndFact_N != 0.1 && rndFact_N != 0.5 && rndFact_N != 1) {
			rndFact_N = 0.1;
		}
		// die neue Vorgabenliste
		var prefsList = new Array (showDlog_N, horGap, rndFact_N);
		// in eine Textkette verwandeln
		var prefString = prefsList.join("\n");
		// zur Funktion schicken, welche das Ergebnis in eine Datei schreibt
		writeResult(prefString, "/TabStops_No_501.txt");
		// das Ergebnis zum Aufruf zurckschicken
		return [horGap, rndFact_N];
	}
	else{
		// wenn "Abbrechen", den Dialog entfernen ...
		aDialog.destroy();
		// ... die Funktion aufrufen, welche die Einstellungen zurcksetzt ...
		reStore();
		// ... und die Ausfhrung abbrechen
		exit();
	}
}

function askUser_Yes() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 184;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"Definierte TabStops"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Erste zu verndernde Spalte:", minWidth:labelWidth});
						var firstField = integerEditboxes.add({editValue:firstStop, minimumValue:1, maximumValue:10, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"      ", minWidth:12});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Rundung der Positionen:", minWidth:labelWidth});
						var rndField = realEditboxes.add({editValue:rndFact_Y, minWidth:fieldWidth});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:70});
				with(showButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"Dialog nicht mehr zeigen", checkedState:ck02});
					radiobuttonControls.add({staticLabel:"Dialog zeigen", checkedState:ck03});
				}
			}
		}
	}
	if (aDialog.show() == true) {
		// die Eingaben auswerten
		showDlog_Y = showButtons.selectedButton;
		firstStop  = firstField.editValue;
		rndFact_Y  = rndField.editValue;
		// den Dialog entfernen
		aDialog.destroy();
		// die Eingabe testen
		if (rndFact_Y != 0 && rndFact_Y != 0.1 && rndFact_Y != 0.5 && rndFact_Y != 1) {
			rndFact_Y = 0.1;
		}
		// die neue Vorgabenliste
		var prefsList = new Array (showDlog_Y, firstStop, rndFact_Y);
		// in eine Textkette verwandeln
		var prefString = prefsList.join("\n");
		// zur Funktion schicken, welche das Ergebnis in eine Datei schreibt
		writeResult(prefString, "/TabStops_Yes_501.txt");
		// das Ergebnis zum Aufruf zurckschicken
		return [firstStop, rndFact_Y];
	}
	else{
		// wenn "Abbrechen", den Dialog entfernen ...
		aDialog.destroy();
		// ... die Funktion aufrufen, welche die Einstellungen zurcksetzt ...
		reStore();
		// ... und die Ausfhrung abbrechen
		exit();
	}
}

// das Ergebnis in eine Datei schreiben //////////////////////////////////////////
function writeResult(curPrefs, fiName) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + fiName);
	}
	else {
		var f = File("~/Library/Preferences" + fiName);
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Einstellungs-nderungen zurcksetzen //////////////////////////////////////
function reStore() {
	// die Masseinheiten zurcksetzen (falls notwendig) 
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	// den Nullpunkt zurcksetzen (falls notwendig) 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = zP; 
	}
}

// den Benutzer informieren //////////////////////////////////////////////////////
function infUser() {
	// das Ende der Aktion verknden
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	// eine kleine Pause
	$.sleep(555);
	// das Fenster schliessen
	dlog.close();
}